#ifndef _QPROJECTIONMATRIXWIDGET_H_
#define _QPROJECTIONMATRIXWIDGET_H_

#include <QtGui>

#include "math/ProjectionMatrix.h"

#include "ui_qprojectionmatrixwidget.h"

namespace projection
{

class QProjectionMatrixWidget : public QWidget
{
    Q_OBJECT

public:

    QProjectionMatrixWidget(QWidget* pParent=0, Qt::WFlags flag=0);
    ~QProjectionMatrixWidget();

    void setMatrix(const ProjectionMatrix& matrix);
    ProjectionMatrix getMatrix() const;

    void clear();

signals:

    void matrixChanged(const ProjectionMatrix& matrix);

private slots:

    void on_fovEdit_editingFinished();
    void on_aspectRatioEdit_editingFinished();
    void on_nearEdit_editingFinished();
    void on_farEdit_editingFinished();
    void on_offaxisXEdit_editingFinished();
    void on_offaxisYEdit_editingFinished();
    void checkValueChanged();

private:

    Ui::QProjectionMatrixWidget ui;

    ProjectionMatrix m_matrix;
    bool m_bStopSlot;       //??
};

}; // projection

#endif // _QPROJECTIONMATRIXWIDGET_H_
